@echo off

rem  This batch file compiles and assembles hp48 code with the HP assembler.
rem  Source files end in .s, do not append .s to filename when calling.
rem  Remove the -N option from sasm if any code objects in source.
rem  This makes sasm create a listfile.  Necessary because asm errors
rem  are not displayed.  Listfile must be searched for ERROR.
rem  Env var SASM_LIB must point to directory where sasm files are found.
rem  This batch file overwrites files with same basename as being compiled
rem  with extensions of .a .m .o (and .l if listfile is generated).

SET SASM_LIB=C:\HPTOOLS
if exist %1.s goto found
echo Can't open %1.s
goto end
:found
rplcomp %1.s %1.a
if exist %1 del %1
sasm -N %1.a
echo OUTPUT %1 > %1.m
echo SUPPRESS XREF >> %1.m
echo SUPPRESS SUMMARY >> %1.m
echo SEARCH C:\HPTOOLS\ENTRIES.o >> %1.m
echo RELOCATE %1.o >> %1.m
echo END >> %1.m
sload -H %1.m
for %%f in (%1.a %1.m %1.o) do del %%f
:end
