	TITLE FastOFF
**miscdoc+**************************************************
*
*    File: fastoffh.s
* Machine: Charlemagne, Alcuin
* Created: July/31/1998 , J-Y Avenard
* Purpose: Ultra fast off for any HP48
*
**+miscdoc**************************************************

INCLUDE hpentr.a

ASSEMBLE

sAlcuin	EQU	9	Be sure not to be 0,1,2,11 or 12, since they are used by DeepSleep

*
* For GX only !!
*
BSWADDR		EQU	#7F000
LINECOUNTg 	EQU	#8069A
CONFTAB		EQU	#8052B
		
	NIBASC /HPHP48-X/

RPL
::
 CK0
 ALARM? ?SEMI	( if Alarm Due, skip off )
 CODE
	GOSBVL	=SAVPTR
	CLRST
	AD0EX			A=AVMEM
	A=A+A	A		Carry will be set on GX
	GONC	Charles1
	ST=1	sAlcuin
Charles1
	GOSUB	OFF.SBR
	GOVLNG	=GETPTRLOOP
  
*
* Entry:  ST.sAlcuin must be set on G series
* Output: None
*
OFF.SBR
 	GOSBVL	=DisableIntr
 	?ST=0	sAlcuin
	GOYES	Charles2
* We disable the Bank Switcher
	D0=(5)	BSWADDR
	C=DAT0	B
* We enable the ROM
	D0=(5)	LINECOUNTg
	C=DAT0	B
	CBIT=1	7
	DAT0=C	B
	D0=(5)	LINECOUNT
	DAT0=C	B
Charles2
	ST=0	0
	GOSBVL	=DeepSleep	IF ST=1.0 THEN IT WILL CRASH
	?ST=0	sAlcuin
	GOYES	Charles3
* We disable the Bank Switcher (it will be enabled by the system)
	D0=(5)	BSWADDR
	C=DAT0	B
*
* We disable the ROM
* On GX or extended G only!
*
	D0=(5)	(CONFTAB)+10
	A=DAT0	B
	?A=0	P
	GOYES	Charles3	If on a G, then exit
	D0=(5)	LINECOUNTg
	C=DAT0	B
	CBIT=0	7
	DAT0=C	B
	D0=(5)	LINECOUNT
	DAT0=C	B
Charles3
	GOVLNG	=AllowIntr 	Enable the interrupt and exit
 ENDCODE
 InitEnab ( I don't think it is needed, but that's what they do in the ROM)
;
