**********************************************************************
* Desc:		Pollard p-1 factorization method
* Stack:	( Z --> Z1 Z2 )
*		or % or $
* Notes:
*		This works well if p-1 has only small factors
*
*		See UBasic programs by Malm
*
*		This is Jazz source code
*
**********************************************************************

* Upper bound for factor of p-1

DEFINE UBnd	2000

* Gcd interval (gcd's are traded for modulo multiplications)

DEFINE Cc	20

::
  CK1NOLASTWD
  FastLib CK1Z			( --> Z )
  HXS 2 30			( B=3 )
  HXS 2 10			( T=1 )
  THREE				( I=3 )
  {{ N B T I }}
  B HXS 2 40 N ModPow B!
  BEGIN
	I #>$ DISPROW1
	B I #>Z N ModPow B!
	I #1+ I!
	I Cc #/ DROP #0= IT
	:: B HXS 2 10 QSub N ZGcd T! ;
	I UBnd #>
	T ZIsOne? NOT OR
  UNTIL
  T N T QDiv
  ABND
;
**********************************************************************










