*Insertion Sort*********************************
*                                              
* Name: Insertion Sort                         
*                                              
* Entry: 1) {}                                 
*                                              
* Exit: 1) {} sorted                           
*                                              
* Calls: SAVPTR GETPTRLOOP                     
*                                              
* Alogrithm:                                   
* Get number of items in the list              
* test curr and prev.                          
* if curr is less than prev loop back          
*   copying items down one pos.  stop if       
*   found where curr is less than the new      
*   prev also stop if reached front of list    
* write into new pos.                          
* continue down the list                       
*                                              
* Registers: A[A] B[A] C[A] D[A] D0 D1 R0[A]    
*                                              
* Notes:                                       
*     - expects {} of 5 nibbles if you give it 
*       something else you are on your own !!! 
*     - sorts back into same list              
*                                              
* Written       12.10.94        Will Laughlin            
* Rewritten     2.2.95          Will Laughlin                  
*       -Speeded up loops                       
************************************************
CODE
	GOSBVL  =SAVPTR
	A=DAT1  A
	D0=A
	A=DAT0  A
	LC(5)   =DOLIST
	D=0     A
	?A#C    A
	GOYES   Done
	D0=D0+  5       
	LC(5)   =SEMI
Lp      
	A=DAT0  A
	?A=C    A       
	GOYES   Done
	D=D+1   A
	D0=D0+  5
	GONC    Lp
Done
	C=D     A
	RSTK=C
	A=DAT1  A
	D0=A
	D1=A
	D0=D0+  5       
	D1=D1+  10      
	C=C-1   A
	GOC     done
	B=C     A       
MainLp
	B=B-1   A
	GOC     done
	A=DAT0  A
	C=DAT1  A      
	?C<A    A
	GOYES   LoopBack
	D0=D0+  5
	D1=D1+  5       
	GONC    MainLp

****************************************************************
LoopBack
	A=C     A
	C=RSTK
	RSTK=C
	C=C-B   A
	D=C     A
	CD0EX
	RSTK=C
	D0=C
*       CD1EX
*       RSTK=C
*       D1=C
	D=D-1   A
InnerLp
	D=D-1   A
	GOC     Foundit
	C=DAT0  A
	?C<A    A       * test this loc.
	GOYES   Foundit
	DAT1=C  A
	D0=D0-  5
	D1=D1-  5
	GONC    InnerLp

****************************************************************
Foundit
	DAT1=A  A
	C=RSTK
	D1=C
	D0=C
	D0=D0+  5
	D1=D1+  10
	GONC    MainLp
done
	C=RSTK
	GOVLNG  =GETPTRLOOP
ENDCODE
