**********************************************************************
* Desc:		Predicate for polynomial factorization sort
* Stack:	( Lf1 Lf2 --> flag )
* Notes:	The sort is such that when the factors are traversed
*		simultaneously
*			Z vs P			--> TRUE
*			P vs Z			--> FALSE
*			deg(P1) < deg(P2)	--> TRUE
*			deg(P1) > deg(P2)	--> FALSE
*			abs(Z1) < abs(Z2)	--> TRUE
*			abs(Z1) > abs(Z2)	--> FALSE
*			Z1 = Z2			--> traverse forward
*			Z1 < 0			--> TRUE
*
*		UNTESTED!
*
**********************************************************************
NULLNAME IsF>F?
CODE
		GOSUBL	Pop2Savptr	D0=->Lf1	D1=->Lf2
		A=0	A
cmpffloop{}	R0=A	A		A[A]=depth=0
		D0=D0+	5		Skip leading DOLISTs
		D1=D1+	5
cmpffloop	A=DAT0	A
		C=DAT1	A
		?A=C	A
		GOYES	cmpffsame	Same type - compare objects
cmpffexit	?A<C	A		HSTR:02A4E  LIST=#02A74  SEMI:#312B
		GOYES	cmpffpush
cmpffpush	GOVLNG	=GPPushT/FLp
cmpffsame	LC(5)	=DOHSTR
		?A=C	A
		GOYES	cmpffhstr	Compare integers
		LC(2)	=DOLIST
		?A=C	A
		GOYES	cmpllsame	Compare lists
		A=R0	A
		A=A-1	A		depth--
		?A#0	A
		GOYES	cmpffloop{}
		GOVLNG	=GPPushTLoop	Should not happen!
cmpllsame	GOSUBL	QLEN2		A[A]=len1	C[A]=len2
		?A#C	A
		GOYES	cmpffexit
		A=R0	A
		A=A+1	A		depth++
		GONC	cmpffloop{}		
cmpffhstr	GOSUBL	ZNCMP
		?A#0	P
		GOYES	cmpssdiff	Not equal magnitude - continue
		D0=D0-	5
		C=DAT0	A
		AD0EX
		A=A+C	A
		D0=A			->Z1tail
		D1=D1-	5
		C=DAT1	A
		AD1EX
		A=A+C	A
		D1=A			->Z2tail
		D0=D0-	1		->Z1sign
		D1=D1-	1		->Z2sign
		A=DAT0	B
		C=DAT1	B
		D0=D0+	1
		D1=D1+	1
		?A=C	P
		GOYES	cmpffloop	Continue if same sign
cmpssdiff	A=A+1	P		CS if Z1 is negative
		GOTO	cmpffpush
ENDCODE
**********************************************************************



		
